﻿void ToonSpecular_float(
    in float3 viewDir,
    in float3 worldNormal,
    in float3 worldSpaceLightDir,
    out float3 SpecularLightBlinn,
    out float3 SpecularLightPhong)
{
    //blinn
    float3 normal = normalize(worldNormal);
    float3 halfVector = normalize(worldSpaceLightDir + viewDir);
    SpecularLightBlinn = dot(normal, halfVector);

    //phong
    float3 reflectionVector = reflect(worldSpaceLightDir, normal);
    SpecularLightPhong = dot(-viewDir, reflectionVector);
}